//Version  January 7, 2007 Final
//+X================================================================X+
//|                                                 LRMASeries()_mqh |
//|                             LRMA code: Copyright  2005, alexjou |
//|              MQL4 LRMASeries()Copyright  2006, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail_redcom_ru | 
//+X================================================================X+
  /*

  +-------------------------------------- <<<  LRMASeries() >>> -----------------------------------------------+

  +-----------------------------------------+ <<<  >>> +----------------------------------------------------+

    LRMASeries()             
      ,            _   , 
    LRMA_limit    ,   !  ,    LRMASeries(),  
      _       (): MetaTrader\experts\include\_  ,
      nLRMA_bar ,  nLRMA_MaxBar,   LRMASeries()    !   !
  ,  ,           -    ! 
      LRMASeries()          ,  
    _      LRMASeries()        ,
            !      
     LRMASeries(),        nLRMA____  dLRMA____
    LRMASeries()         ,    
    ,             LRMASeries() 
      (nLRMA_number)_ 

  +-------------------------------------+ <<<   >>> +-------------------------------------------------+

  nLRMA_n      -      LRMASeries()_ (0, 1, 2, 3 ______)
  nLRMA_MaxBar -  ,          (nLRMA_bar)_   
                 Bars-1-period;   "period" -    ,        dLRMA_series   
                 ; 
  nLRMA_limit  -            ,     
                    Bars-IndicatorCounted()-1;
  nLRMA_Period -  _      !        
                 500_                 ,            
                 dLRMA_TempBuffer[1][500]    dLRMA_TEMPBUFFER[1][500]_       3_
  dLRMA_series -   ,      LRMASeries();
  nLRMA_bar    -   ,             
                 _            nLRMA_limit!!!

  +------------------------------------+ <<<   >>> +-------------------------------------------------+

  LRMASeries() -   dLRMA_ret_val_          nLRMA_bar      nLRMA_MaxBar-nLRMA_Length 
                  LRMASeries()   !!!
  nLRMA_reset  - ,    ,   0 ,       ,
                 0,    _      ,   !!!

  +-----------------------------------+ <<<   >>> +-----------------------------------------------+

          LRMASeries()  ,           0,   
        ,             LRMASeries() 
     LRMASeriesResize()   : LRMASeriesResize(MaxLRMA_number+1); 
    nLRMA_n(MaxLRMA_number)      LRMASeries,     ,
    nLRMA_n_ 

  +--------------------------------------+ <<<   >>> +-------------------------------------------------+
  
           ,       
  _       LRMASeries()       \MetaTrader\EXPERTS\LOGS\_ ,   
    LRMASeries()   ,   ,  MQL4 ,       
       _     LRMASeries()  LRMASeries()  MQL4 ,
                   _      
    LRMASeries()  nLRMA_number       nJLRMAResize_Size   
         _        
      nLRMA_limit_         init()    
          LRMASeries(),    LRMASeriesResize()      
          _      LRMASeries()  
           nLRMA_bar,        
  _  ,            
    ,      LRMASeries()         ,      
    _       LRMASeries()       
        _        
     ,       init()_ 
  
  +---------------------------------+ <<<     >>> +--------------------------------------------+

//----+   LRMASeries()
#include <LRMASeries_mqh>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----    
SetIndexStyle (0,DRAW_LINE); 
//---- 1      (    LRMASeries()     !!!)
SetIndexBuffer(0,Ind_Buffer);
//----+      LRMASeries, nLRMA_n=1(    LRMASeries)
if(LRMASeriesResize(1)==0)return(-1);
return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator function                                        |
//+------------------------------------------------------------------+
int start()
{
//----+        
int reset,bar,MaxBar,limit,counted_bars=IndicatorCounted(); 
//----    
if (counted_bars<0)return(-1);
//----      
if (counted_bars>0) counted_bars--;
//----     ,        
int limit=Bars-counted_bars-1;
MaxBar=Bars-1;
//----+ 
for(bar=limit;bar>=0;bar--)
 (
  double Series=Close[bar];
  //----+    LRMASeries()  0    Ind_Buffer[], 
  double Resalt=LRMASeries(0,MaxBar,limit,Length,Series,bar,reset);
  if (reset!=0)return(-1);
  Ind_Buffer[bar]=Resalt;
 }
return(0);
}
//----+ 

*/
//+X================================================================X+
//|  LRMASeries() function                                           |
//+X================================================================X+   

//----++ <<<     >>> 
double dLRMA_TempBuffer[1][501];
double dLRMA_TEMPBUFFER[1][501],dLRMA_den_x[1];
int nLRMA_range1, nLRMA_range2, nLRMA_rangeMin; 
int nLRMA_sum_x[1], nLRMA_sum_x2[1], nLRMA_TIME[1];
//----++
double dLRMA_sum_y, dLRMA_sum_xy, dLRMA_var_tmp;
double dLRMA_A, dLRMA_B, dLRMA_ret_val;
int    nLRMA_iii, nLRMA_loop_begin,nLRMA_Error;
int    nLRMA_Tnew,nLRMA_Told,nLRMA_n,nLRMA_Resize;

//----++ <<<   LRMASeries() >>> +---------------------------------------------------------------------------+

double LRMASeries
 (
  int nLRMA_number, int nLRMA_MaxBar, int nLRMA_limit, int nLRMA_period, double dLRMA_series, int nLRMA_bar, int& nLRMA_reset
 )
//----++---------------------------------------------------------------------------------------------------------------------+
{
nLRMA_n = nLRMA_number;

nLRMA_reset = 1;
//=====+ <<<    >>> +--------------------------------------------------------------------+
if (nLRMA_bar == nLRMA_limit)
 {
  //----++     LRMASeries()
  if (nLRMA_Resize < 1)
   {
    Print(StringConcatenate("LRMASeries number = ", nLRMA_n,
         "_         LRMASeriesResize()"));
    if(nLRMA_Resize == 0)
          Print(StringConcatenate("LRMASeries number = ", nLRMA_n,
                "_      LRMASeriesResize()   "));
         
    return(0.0);
   }
  //----++       ,   LRMASeries()
  nLRMA_Error = GetLastError();
  if(nLRMA_Error > 4000)
   {
    Print(StringConcatenate("LRMASeries number = ", nLRMA_n,
         "_  ,     LRMASeries() number = ", nLRMA_n, " !!!"));
    Print(StringConcatenate("LRMASeries() number = ", nLRMA_n, "_ ", LRMA_ErrDescr(nLRMA_Error)));  
   } 
                                                   
  //----++       nLRMA_number  nLRMAResize_Number
  if (ArraySize(nLRMA_sum_x) < nLRMA_number) 
   {
    Print(StringConcatenate("LRMASeries number = ", nLRMA_n,
                 "_ !!!     nLRMA_number  LRMASeries()"));
    Print(StringConcatenate("LRMASeries() number = ", nLRMA_n,
            "_       nLRMAResize_Size  LRMASeriesResize()"));
    return(0.0);
   }
 }
//----++ +------------------------------------------------------------------------------------------------+ 
  
if (nLRMA_bar > nLRMA_MaxBar){nLRMA_reset = 0; return(0.0);}

if(nLRMA_bar != nLRMA_limit)
        for(nLRMA_iii = nLRMA_period; nLRMA_iii >= 0; nLRMA_iii--)
                                          dLRMA_TempBuffer[nLRMA_n][nLRMA_iii + 1] =
                                                                dLRMA_TempBuffer[nLRMA_n][nLRMA_iii];
dLRMA_TempBuffer[nLRMA_n][0] = dLRMA_series;

if (nLRMA_period < 3)nLRMA_period = 3;
else if (nLRMA_period > nLRMA_rangeMin){nLRMA_period = nLRMA_rangeMin;}

if (nLRMA_bar > nLRMA_MaxBar - nLRMA_period){nLRMA_reset = 0; return(0.0);}

//----++ <<<    >>> +-------------------------+
if (nLRMA_bar == nLRMA_MaxBar - nLRMA_period)
 {
  for(nLRMA_iii = 1; nLRMA_iii <= nLRMA_period; nLRMA_iii++)
   {
    nLRMA_sum_x[nLRMA_n]  += nLRMA_iii;
    nLRMA_sum_x2[nLRMA_n] += nLRMA_iii * nLRMA_iii;
   }
  dLRMA_den_x[nLRMA_n] = nLRMA_period * nLRMA_sum_x2[nLRMA_n] 
                - nLRMA_sum_x[nLRMA_n] * nLRMA_sum_x[nLRMA_n];
 }
//----++ -------------------------------------------------------+  

if (nLRMA_period<1)nLRMA_period=1;

//----++        nLRMA_bar
if (nLRMA_limit >= nLRMA_MaxBar)
 if (nLRMA_bar == 0)
  if (nLRMA_MaxBar > nLRMA_period)
   if (nLRMA_TIME[nLRMA_n] == 0)
                        Print(StringConcatenate("LRMASeries number = ", nLRMA_n,
                        "_ !!!     ",
                                             " nLRMA_bar   !!!"));  

//----+ <<<    >>> +-----------------------------------------------------+
if (nLRMA_bar == nLRMA_limit)
 if (nLRMA_limit < nLRMA_MaxBar)
  {
   nLRMA_Tnew = Time[nLRMA_limit + 1];
   nLRMA_Told = nLRMA_TIME[nLRMA_n];
    //--+
   if(nLRMA_Tnew == nLRMA_Told)
   for(nLRMA_iii = nLRMA_period; nLRMA_iii >= 1; nLRMA_iii--)
                               dLRMA_TempBuffer[nLRMA_n][nLRMA_iii] =
                                               dLRMA_TEMPBUFFER[nLRMA_n][nLRMA_iii];  
   //--+   
   if(nLRMA_Tnew != nLRMA_Told)
    {
     nLRMA_reset = -1;
     //--+       nLRMA_limit  LRMASeries()
     if (nLRMA_Tnew > nLRMA_Told)
       {
       Print(StringConcatenate("LRMASeries number = ", nLRMA_n,
                   "_ !!!  nLRMA_limit  LRMASeries() ,  "));
       }
     else 
       { 
       int nLRMA_LimitERROR = nLRMA_limit + 1 - iBarShift(NULL, 0, nLRMA_Told, TRUE);
       Print(StringConcatenate("LRMASeries number = ", nLRMA_n,
               "_ !!!  nLRMA_limit  LRMASeries() ,    ",
                                                                                     nLRMA_LimitERROR));
       }
     //--+   nLRMA_reset=-1;     LRMASeries
     return(0);
    } 
  }                    
//----++--------------------------------------------------------------------------------------------------+

//+---    +--------------------------------+
if (nLRMA_bar == 1)
 if (nLRMA_limit != 1)
  {
   nLRMA_TIME[nLRMA_n] = Time[2];
   for(nLRMA_iii = nLRMA_period; nLRMA_iii >= 1; nLRMA_iii--)
                           dLRMA_TEMPBUFFER[nLRMA_n][nLRMA_iii] =
                                dLRMA_TempBuffer[nLRMA_n][nLRMA_iii];      
  }
//+---++---------------------------------------------------------------+  

  nLRMA_loop_begin = nLRMA_period - 1;
  dLRMA_sum_y   = 0.0;
  dLRMA_sum_xy  = 0.0;
  for (nLRMA_iii = 1; nLRMA_iii <= nLRMA_period; nLRMA_iii++)
   {
    dLRMA_var_tmp  = dLRMA_TempBuffer[nLRMA_n][nLRMA_loop_begin - nLRMA_iii + 1];  
    dLRMA_sum_y   += dLRMA_var_tmp;
    dLRMA_sum_xy  += nLRMA_iii * dLRMA_var_tmp; 
   }
  dLRMA_B = (nLRMA_period * dLRMA_sum_xy - 
                      nLRMA_sum_x[nLRMA_n] * dLRMA_sum_y) / dLRMA_den_x[nLRMA_n];
                  
  dLRMA_A = (dLRMA_sum_y - dLRMA_B * nLRMA_sum_x[nLRMA_n]) / nLRMA_period;             
  //
  dLRMA_ret_val = dLRMA_A + dLRMA_B * nLRMA_period;   
 //----
 //----++         JLRMASeries()
 nLRMA_Error = GetLastError();
 if(nLRMA_Error > 4000)
   {
    Print(StringConcatenate("LRMASeries number = ",
                nLRMA_n, "_    LRMASeries()  !!!"));
                
    Print(StringConcatenate
                  ("LRMASeries number = ", nLRMA_n, "_ ", LRMA_ErrDescr(nLRMA_Error)));   
    return(0.0);
   }
  nLRMA_reset = 0;
  return(dLRMA_ret_val);
  
//----+     LRMASeries() --------------------------+  
}
//+X==============================================================================================X+
// LRMASeriesResize -               | 
//  LRMASeries_  : LRMASeriesResize(5);  5 -      | 
// LRMASeries()  _      LRMASeriesResize     |
//                                        |
//+X==============================================================================================X+
int LRMASeriesResize(int nLRMAResize_Size)
 {
//----+
  if (nLRMAResize_Size < 1)
   {
    Print("LRMASeriesResize: !!!  nLRMAResize_Size     !!!"); 
    nLRMA_Resize = -1; 
    return(0);
   }
  //----+    
  nLRMA_range1 = ArrayRange(dLRMA_TempBuffer, 1) - 1; 
  nLRMA_range2 = ArrayRange(dLRMA_TEMPBUFFER, 1) - 1;   
  nLRMA_rangeMin = MathMin(nLRMA_range1, nLRMA_range2);
  if (nLRMAResize_Size == -2)return(nLRMA_rangeMin);
  //----+  
  int nLRMAResize_reset, nLRMAResize_cycle;
  //--+
  while(nLRMAResize_cycle == 0)
   {
    //----++ <<<     >>>  +-----------------------------+
    if(ArrayResize(dLRMA_TempBuffer, nLRMAResize_Size) == 0){nLRMAResize_reset = -1; break;}
    if(ArrayResize(dLRMA_TEMPBUFFER, nLRMAResize_Size) == 0){nLRMAResize_reset = -1; break;}
    if(ArrayResize(nLRMA_sum_x ,     nLRMAResize_Size) == 0){nLRMAResize_reset = -1; break;}
    if(ArrayResize(nLRMA_sum_x2,     nLRMAResize_Size) == 0){nLRMAResize_reset = -1; break;}
    if(ArrayResize(dLRMA_den_x,      nLRMAResize_Size) == 0){nLRMAResize_reset = -1; break;}
    if(ArrayResize(nLRMA_TIME,       nLRMAResize_Size) == 0){nLRMAResize_reset = -1; break;}
    //----++-------------------------------------------------------------------------------+
    nLRMAResize_cycle = 1;
   }
  //--+
  if (nLRMAResize_reset == -1)
   {
    Print(StringConcatenate
        ("LRMASeriesResize: !!!   ",
             "     LRMASeries()_"));
             
    int nLRMAResize_Error = GetLastError();
    if (nLRMAResize_Error > 4000)
            Print(StringConcatenate("LRMASeriesResize: ",
                                     LRMA_ErrDescr(nLRMAResize_Error)));    
    nLRMA_Resize = -2;
    return(0);
   }
  else  
   {
    Print(StringConcatenate
         ("LRMASeriesResize: LRMASeries Size = ", nLRMAResize_Size));
    nLRMA_Resize = nLRMAResize_Size;
    return(nLRMAResize_Size);
   }  
//----+
 }
/*
//+X====================================================================================================X+
LRMASeriesAlert -                     |
 LRMASeries_                                                                                      |
  --------------------------    --------------------------                               |
LRMASeriesAlert_Number                                                                                   |
LRMASeriesAlert_ExternVar      nLRMA_Phase                          |
LRMASeriesAlert_name      nLRMA_Length,  LRMASeriesAlert_Number=0_   |                                                  
  --------------------------    -----------------------                               |
  int init()                                                                                             |
//----                                                                                                   |
 -                                                        |
                                                                                                         |
//----                                            |                                                           
LRMASeriesAlert(0,"Length1",Length1);                                                                    |
LRMASeriesAlert(0,"Length2",Length2);                                                                    |
//----                                                                            |
return(0);                                                                                               |
}                                                                                                        |
//+X====================================================================================================X+
*/
void LRMASeriesAlert
 (
  int LRMASeriesAlert_Number, string LRMASeriesAlert_name, int LRMASeriesAlert_ExternVar
 )
 {
  //----        
   if (LRMASeriesAlert_Number == 0)
     if (LRMASeriesAlert_ExternVar < 3)
          Alert(StringConcatenate(" ", LRMASeriesAlert_ExternVar, "     3", 
                            "    " ,LRMASeriesAlert_ExternVar,"    3"));
                            
   int LRMASeriesAlert_MaxPeriod = ArrayRange(dLRMA_TempBuffer, 1);  
   if (LRMASeriesAlert_Number == 0)
     if (LRMASeriesAlert_ExternVar > LRMASeriesAlert_MaxPeriod)
      Alert(StringConcatenate
               (" ",LRMASeriesAlert_name,"     ",
                           LRMASeriesAlert_MaxPeriod, "    ",
                                   LRMASeriesAlert_ExternVar,"    ",
                                       LRMASeriesAlert_MaxPeriod, "    ",
                                         "  nLRMA_period,    ",
                                                        " dLRMA_TempBuffer  dLRMA_TEMPBUFFER  LRMASeries"));
          
 }
//     01_12_2006  
//+X================================================================X+
//|                                      LRMA_ErrDescr_RUS(MQL4)_mqh |
//|                      Copyright  2004, MetaQuotes Software Corp_ |
//|                                       http://www_metaquotes_net/ |
//+X================================================================X+
string LRMA_ErrDescr(int error_code)
 {
  string error_string;
//----
  switch(error_code)
    {
     //---- MQL4  
     case 4000: error_string = StringConcatenate("  = ",error_code,"_  ");                                                  break;
     case 4001: error_string = StringConcatenate("  = ",error_code,"_   ");                              break;
     case 4002: error_string = StringConcatenate("  = ",error_code,"_      ");                 break;
     case 4003: error_string = StringConcatenate("  = ",error_code,"_     ");                                break;
     case 4004: error_string = StringConcatenate("  = ",error_code,"_     ");                break;
     case 4005: error_string = StringConcatenate("  = ",error_code,"_       ");                 break;
     case 4006: error_string = StringConcatenate("  = ",error_code,"_     ");                         break;
     case 4007: error_string = StringConcatenate("  = ",error_code,"_     ");                             break;
     case 4008: error_string = StringConcatenate("  = ",error_code,"_  ");                                 break;
     case 4009: error_string = StringConcatenate("  = ",error_code,"_    ");                       break;
     case 4010: error_string = StringConcatenate("  = ",error_code,"_     ");                           break;
     case 4011: error_string = StringConcatenate("  = ",error_code,"_   ");                                      break;
     case 4012: error_string = StringConcatenate("  = ",error_code,"_     ");                                  break;
     case 4013: error_string = StringConcatenate("  = ",error_code,"_   ");                                             break;
     case 4014: error_string = StringConcatenate("  = ",error_code,"_  ");                                         break;
     case 4015: error_string = StringConcatenate("  = ",error_code,"_   (never generated error)");                break;
     case 4016: error_string = StringConcatenate("  = ",error_code,"_  ");                                 break;
     case 4017: error_string = StringConcatenate("  = ",error_code,"_  DLL  ");                                     break;
     case 4018: error_string = StringConcatenate("  = ",error_code,"_   ");                             break;
     case 4019: error_string = StringConcatenate("  = ",error_code,"_   ");                                  break;
     case 4020: error_string = StringConcatenate("  = ",error_code,"_      ");            break;
     case 4021: error_string = StringConcatenate("  = ",error_code,"_    ,   ");     break;
     case 4022: error_string = StringConcatenate("  = ",error_code,"_   (never generated error)");                      break;
     case 4050: error_string = StringConcatenate("  = ",error_code,"_    ");                  break;
     case 4051: error_string = StringConcatenate("  = ",error_code,"_    ");                     break;
     case 4052: error_string = StringConcatenate("  = ",error_code,"_    ");                         break;
     case 4053: error_string = StringConcatenate("  = ",error_code,"_  ");                                              break;
     case 4054: error_string = StringConcatenate("  = ",error_code,"_   -");                break;
     case 4055: error_string = StringConcatenate("  = ",error_code,"_   ");                         break;
     case 4056: error_string = StringConcatenate("  = ",error_code,"_  ");                                        break;
     case 4057: error_string = StringConcatenate("  = ",error_code,"_    ");                     break;
     case 4058: error_string = StringConcatenate("  = ",error_code,"_    ");                         break;
     case 4059: error_string = StringConcatenate("  = ",error_code,"_      ");                      break;
     case 4060: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4061: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4062: error_string = StringConcatenate("  = ",error_code,"_    string");                              break;
     case 4063: error_string = StringConcatenate("  = ",error_code,"_    integer");                             break;
     case 4064: error_string = StringConcatenate("  = ",error_code,"_    double");                              break;
     case 4065: error_string = StringConcatenate("  = ",error_code,"_     ");                       break;
     case 4066: error_string = StringConcatenate("  = ",error_code,"_      ");      break;
     case 4067: error_string = StringConcatenate("  = ",error_code,"_     ");                     break;
     case 4099: error_string = StringConcatenate("  = ",error_code,"_  ");                                                 break;
     case 4100: error_string = StringConcatenate("  = ",error_code,"_     ");                                  break;
     case 4101: error_string = StringConcatenate("  = ",error_code,"_   ");                                      break;
     case 4102: error_string = StringConcatenate("  = ",error_code,"_    ");                               break;
     case 4103: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4104: error_string = StringConcatenate("  = ",error_code,"_     ");                         break;
     case 4105: error_string = StringConcatenate("  = ",error_code,"_     ");                                     break;
     case 4106: error_string = StringConcatenate("  = ",error_code,"_  ");                                          break;
     case 4107: error_string = StringConcatenate("  = ",error_code,"_      ");             break;
     case 4108: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4109: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4110: error_string = StringConcatenate("  = ",error_code,"_    ");                                break;
     case 4111: error_string = StringConcatenate("  = ",error_code,"_    ");                               break;
     case 4200: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4201: error_string = StringConcatenate("  = ",error_code,"_    ");                      break;
     case 4202: error_string = StringConcatenate("  = ",error_code,"_   ");                                        break;
     case 4203: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4204: error_string = StringConcatenate("  = ",error_code,"_   ");                                           break;
     case 4205: error_string = StringConcatenate("  = ",error_code,"_   ");                                    break;
     case 4206: error_string = StringConcatenate("  = ",error_code,"_    ");                                break;
     case 4207: error_string = StringConcatenate("  = ",error_code,"_     ");                                break;
     default:   error_string = StringConcatenate("  = ",error_code,"_  ");
    }
//----
  return(error_string);
 }
//+------------------------------------------------------------------+

