//Version  January 7, 2007 Final
//+X================================================================X+
//|                                                ParMASeries()_mqh |
//|          Parabolic approximation code: Copyright  2005, alexjou |
//|        MQL4 ParMASeries() Copyright  2006,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail_redcom_ru | 
//+X================================================================X+ 
  /*
  
  ---------------------------------------- <<<  ParMASeries() >>> ----------------------------------------------

  +-----------------------------------------+ <<<  >>> +----------------------------------------------------+

    ParMASeries()              
        ,              _  
  ,        ParMA_limit    ,    !    ,      
  ParMASeries(),               _                 ():
  MetaTrader\experts\include\_      ,         nParMA_bar  ,    nParMA_MaxBar,    
  ParMASeries()    !   ! , ,     
      -    !    ParMASeries()    
        ,        _      ParMASeries()
         ,        
    !         ParMASeries(),  
           nParMA____  dParMA____  ParMASeries()    
          ,       ,     
         ParMASeries()      (nParMA_number)_

  +-------------------------------------+ <<<   >>> +-------------------------------------------------+

  nParMA_n      -      ParMASeries()_ (0, 1, 2, 3 ______)
  nParMA_MaxBar -  ,        (nParMA_bar)_   
                  Bars-1-period;  "period" -    ,       dParMA_series   
                  ; 
  nParMA_limit  -            ,    
                     Bars-IndicatorCounted()-1;
  nParMA_Period -  _      !       
                  500_                ,            
                  dParMA_TempBuffer[1][500]   dParMA_TEMPBUFFER[1][500]_     3_
  dParMA_series -   ,      ParMASeries();
  nParMA_bar    -   ,            
                  _          nParMA_limit!!!

  +------------------------------------+ <<<   >>> +-------------------------------------------------+

  ParMASeries() -   dParMA_ret_val_     nParMA_bar      nParMA_MaxBar-nParMA_Length 
                   ParMASeries()   !!!
  nParMA_reset  - ,    ,   0 ,      ,
                  0,    _      ,   !!!

  +-----------------------------------+ <<<   >>> +-----------------------------------------------+

          ParMASeries()  ,          0,   
        ,             ParMASeries()
        ParMASeriesResize()       :  ParMASeriesResize(MaxParMA_number+1);
     nParMA_n(MaxParMA_number)      ParMASeries(),   
   ,   nParMA_n_ 
  
  +--------------------------------------+ <<<   >>> +-------------------------------------------------+
  
           ,       
  _      ParMASeries()       \MetaTrader\EXPERTS\LOGS\_ ,   
    ParMASeries()  ,   ,  MQL4 ,       
        _         ParMASeries()   ParMASeries()  MQL4
  ,            _     
      ParMASeries() nParMA_number       nJParMAResize_Size  
                  _       
      nParMA_limit_      init()   
            ParMASeries(),    ParMASeriesResize()    
              _      ParMASeries() 
                nParMA_bar,    
         _  ,        
         ,   ParMASeries()       ,  
            _      ParMASeries()  
            _     
        ,       init()_ 
  +---------------------------------+ <<<     >>> +--------------------------------------------+

//----+   ParMASeries()
#include <ParMASeries_mqh>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----    
SetIndexStyle (0,DRAW_LINE); 
//---- 1     
SetIndexBuffer(0,Ind_Buffer);
//----+      ParMASeries, nParMA_n=1(    ParMASeries)
if(ParMASeriesResize(1)==0)return(-1);
return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator function                                        |
//+------------------------------------------------------------------+
int start()
{
//----+        
int reset,bar,MaxBar,limit,counted_bars=IndicatorCounted(); 
//----    
if (counted_bars<0)return(-1);
//----       (    ParMASeries()     !!!)
if (counted_bars>0) counted_bars--;
//----     ,        
int limit=Bars-counted_bars-1;
MaxBar=Bars-1;
//----+ 
for(bar=limit;bar>=0;bar--)
 (
  double Series=Close[bar];
  //----+    ParMASeries()  0    Ind_Buffer[], 
  double Resalt=ParMASeries(0,MaxBar,limit,Length,Series,bar,reset);
  if (reset!=0)return(-1);
  Ind_Buffer[bar]=Resalt;
 }
return(0);
}
//----+ 
//+X================================================================X+
//|  ParMASeries() function                                          |
//+X================================================================X+   
*/
//----++ <<<     >>> +--------------+ 
double dParMA_TempBuffer[1][501], dParMA_TEMPBUFFER[1][501];
int nParMA_range1, nParMA_range2, nParMA_rangeMin; 
int nParMA_sum_x [1], nParMA_sum_x2[1], nParMA_sum_x3[1];
int nParMA_sum_x4[1], nParMA_TIME[1];
//----++
double dParMA_sum_y, dParMA_sum_xy, dParMA_sum_x2y, dParMA_var_tmp;
double dParMA_A, dParMA_B, dParMA_C, dParMA_D, dParMA_E, dParMA_F; 
double dParMA_K, dParMA_L, dParMA_M, dParMA_P, dParMA_Q, dParMA_R; 
double dParMA_S, dParMA_B0, dParMA_B1, dParMA_B2, dParMA_ret_val;
int    nParMA_iii, nParMA_loop_begin,nParMA_Error,nParMA_Tnew;
int    nParMA_Told,nParMA_n,nParMA_Resize; 
//----++------------------------------------------------------------+
//----++ <<<   ParMASeries() >>> +----------------------------------------------------------------------------------+
double ParMASeries
 (
  int nParMA_number, int nParMA_MaxBar, int nParMA_limit, int nParMA_period, double dParMA_series, int nParMA_bar, int& nParMA_reset
  )
//----++-----------------------------------------------------------------------------------------------------------------------------+
 
{
nParMA_n = nParMA_number;

nParMA_reset = 1;
//----++ <<<    >>> ----------------------------------------------------------------------+
if (nParMA_bar == nParMA_limit)
 {
  //----++     ParMASeries()
  if(nParMA_Resize < 1)
   {
    Print(StringConcatenate("ParMASeries number = ",nParMA_n,
         "_         ParMASeriesResize()"));
    if(nParMA_Resize == 0)
       Print(StringConcatenate("ParMASeries number = ",nParMA_n,
                "_      ParMASeriesResize()   "));
         
    return(0.0);
   }
  //----++       ,   ParMASeries()
  nParMA_Error = GetLastError();
  if(nParMA_Error > 4000)
   {
    Print(StringConcatenate("ParMASeries number = ",nParMA_n,
         "_  ,     ParMASeries() number = ",nParMA_n," !!!"));
    Print(StringConcatenate("ParMASeries number = ",nParMA_n, "_ ",ParMA_ErrDescr(nParMA_Error)));  
   } 
                                                   
  //----++       nParMA_number  nParMAResize_Number
  if (ArraySize(nParMA_sum_x)< nParMA_number) 
   {
    Print(StringConcatenate("ParMASeries number = ",nParMA_n,
                "_ !!!     nParMA_number  ParMASeries()"));
    Print(StringConcatenate("ParMASeries number = ",nParMA_n,
         "_       nParMAResize_Size  ParMASeriesResize()"));
    return(0.0);
   }
 }
//----++ +--------------------------------------------------------------------------------------------------+ 

if (nParMA_bar > nParMA_MaxBar)
               {nParMA_reset = 0; return(0.0);}

if(nParMA_bar != nParMA_limit)
        for(nParMA_iii = nParMA_period; nParMA_iii >= 0; nParMA_iii--)
                              dParMA_TempBuffer[nParMA_n][nParMA_iii+1] =
                                       dParMA_TempBuffer[nParMA_n][nParMA_iii];
                                 
dParMA_TempBuffer[nParMA_n][0] = dParMA_series;

if (nParMA_period < 3)nParMA_period = 3;
else if (nParMA_period > nParMA_rangeMin)nParMA_period = nParMA_rangeMin; 

if (nParMA_bar > nParMA_MaxBar - nParMA_period)
                               {nParMA_reset =0; return(0.0);}

//----++ <<<    >>> +-------------------+
if (nParMA_bar == nParMA_MaxBar - nParMA_period)
{ 
 for(nParMA_iii = 1; nParMA_iii <= nParMA_period; nParMA_iii++)
   {
    dParMA_var_tmp  = nParMA_iii;
    nParMA_sum_x[nParMA_n]   += dParMA_var_tmp; 
    dParMA_var_tmp *= nParMA_iii;
    nParMA_sum_x2[nParMA_n]  += dParMA_var_tmp; 
    dParMA_var_tmp *= nParMA_iii;
    nParMA_sum_x3[nParMA_n]  += dParMA_var_tmp; 
    dParMA_var_tmp *= nParMA_iii;
    nParMA_sum_x4[nParMA_n]  += dParMA_var_tmp; 
   }
}
//----++ --------------------------------------------------+  

if (nParMA_period < 1)nParMA_period = 1;

//----++        nParMA_bar
if (nParMA_limit >= nParMA_MaxBar)
 if (nParMA_bar == 0)
   if (nParMA_MaxBar > nParMA_period)
       if (nParMA_TIME[nParMA_n] == 0)
          Print(StringConcatenate("ParMASeries number = ", nParMA_n,
                     "_ !!!   ",
                         "   nParMA_bar   !!!")); 
                        
if(nParMA_bar == nParMA_limit)
 if (nParMA_limit < nParMA_MaxBar)
{
//----+ <<<    >>> +------------------------------------------------------------------+
nParMA_Tnew = Time[nParMA_limit + 1];
nParMA_Told = nParMA_TIME[nParMA_n];
 //--+
if(nParMA_Tnew == nParMA_Told)
         for(nParMA_iii = nParMA_period; nParMA_iii >= 1; nParMA_iii--)
                                     dParMA_TempBuffer[nParMA_n][nParMA_iii] =
                                                         dParMA_TEMPBUFFER[nParMA_n][nParMA_iii];  
//--+   
if(nParMA_Tnew != nParMA_Told)
    {
     nParMA_reset = -1;
     //--+       nParMA_limit  ParMASeries()
     if (nParMA_Tnew > nParMA_TIME[nParMA_n])
       {
       Print(StringConcatenate("ParMASeries number = ", nParMA_n,
                                 "_ !!!  nParMA_limit  ParMASeries() ,  "));
       }
    else 
       { 
       int nParMA_LimitERROR = nParMA_limit + 1 - iBarShift(NULL, 0, nParMA_TIME[nParMA_n], TRUE);
       
       Print(StringConcatenate("ParMASeries number = ",nParMA_n,
                        "_ !!!  nParMA_limit  ParMASeries() ,    ",
                                                                                                    nParMA_LimitERROR));
       }
  //--+   nParMA_reset=-1;     ParMASeries
  return(0);
  }                     
//----+----------------------------------------------------------------------------------------------------------------+
} 

//+---    +---------------------------------------+
if (nParMA_bar == 1)
 if (nParMA_limit != 1)
  {
   nParMA_TIME[nParMA_n] = Time[2];
   for(nParMA_iii = nParMA_period; nParMA_iii >= 1; nParMA_iii--)
                             dParMA_TEMPBUFFER[nParMA_n][nParMA_iii]=
                                    dParMA_TempBuffer[nParMA_n][nParMA_iii];      
  }
//+---+-----------------------------------------------------------------------+  
 
  // main calculation loop
  nParMA_loop_begin = nParMA_period - 1;
  dParMA_sum_y   = 0.0;
  dParMA_sum_xy  = 0.0;
  dParMA_sum_x2y = 0.0;
  for (nParMA_iii = 1; nParMA_iii <= nParMA_period; nParMA_iii++)
   {
    dParMA_var_tmp  = dParMA_TempBuffer[nParMA_n][nParMA_loop_begin - nParMA_iii + 1];  
    dParMA_sum_y   += dParMA_var_tmp;
    dParMA_sum_xy  += nParMA_iii * dParMA_var_tmp;    
    dParMA_sum_x2y += nParMA_iii * nParMA_iii * dParMA_var_tmp; 
   }
  // initialization
  dParMA_A = nParMA_period;
  dParMA_B = nParMA_sum_x[nParMA_n];  
  dParMA_C = nParMA_sum_x2[nParMA_n]; 
  dParMA_F = nParMA_sum_x3[nParMA_n]; 
  dParMA_M = nParMA_sum_x4[nParMA_n]; 
  dParMA_P = dParMA_sum_y;                   
  dParMA_R = dParMA_sum_xy; 
  dParMA_S = dParMA_sum_x2y;
  // intermediates
  dParMA_D = dParMA_B;  dParMA_E = dParMA_C;  dParMA_K = dParMA_C;  dParMA_L = dParMA_F;
  dParMA_Q = dParMA_D / dParMA_A;  dParMA_E = dParMA_E - dParMA_Q * dParMA_B; 
  dParMA_F = dParMA_F - dParMA_Q * dParMA_C;  dParMA_R = dParMA_R - dParMA_Q * dParMA_P;  
  dParMA_Q = dParMA_K / dParMA_A;  dParMA_L = dParMA_L - dParMA_Q * dParMA_B;
  dParMA_M = dParMA_M - dParMA_Q * dParMA_C;  dParMA_S = dParMA_S - dParMA_Q * dParMA_P; 
  dParMA_Q = dParMA_L / dParMA_E;
  // calculate regression coefficients
  dParMA_B2 = (dParMA_S - dParMA_R * dParMA_Q) / (dParMA_M - dParMA_F * dParMA_Q);
  dParMA_B1 = (dParMA_R - dParMA_F * dParMA_B2) / dParMA_E;
  dParMA_B0 = (dParMA_P - dParMA_B * dParMA_B1 - dParMA_C * dParMA_B2) / dParMA_A;
  // value to be returned - parabolic MA
  dParMA_ret_val = dParMA_B0 + (dParMA_B1 + dParMA_B2 * dParMA_A) * dParMA_A;
 //----
 //----++         JParMASeries()
nParMA_Error = GetLastError();
if(nParMA_Error > 000)
  {
    Print(StringConcatenate("ParMASeries number = ",
                         nParMA_n,"_    ParMASeries()  !!!"));
    Print(StringConcatenate("ParMASeries number = ",nParMA_n,"_ ",ParMA_ErrDescr(nParMA_Error)));   
    return(0.0);
  }
  
  nParMA_reset = 0;
  return(dParMA_ret_val);
//----     ParMASeries() ----------------+ 
}

//--+ --------------------------------------------------------------------------------------------+


//+X==============================================================================================X+
// ParMASeriesResize -               | 
//  ParMASeries_  : ParMASeriesResize(5);  5 -     | 
// ParMASeries()  _      ParMASeriesResize    |
//                                         |
//+X==============================================================================================X+
int ParMASeriesResize(int nParMAResize_Size)
 {
//----+
  if(nParMAResize_Size < 1)
   {
    Print("ParMASeriesResize: !!!  nParMAResize_Size     !!!"); 
    nParMA_Resize = -1; 
    return(0);
   }
  //----+    
  nParMA_range1 = ArrayRange(dParMA_TempBuffer, 1) - 1; 
  nParMA_range2 = ArrayRange(dParMA_TEMPBUFFER, 1) - 1;   
  nParMA_rangeMin = MathMin(nParMA_range1, nParMA_range2);
  if (nParMAResize_Size == -2)return(nParMA_rangeMin);
  //----+
  int nParMAResize_reset, nParMAResize_cycle;
  //--+
  while(nParMAResize_cycle == 0)
   {
    //----++ <<<     >>>  +--------------------------------+
    if(ArrayResize(dParMA_TempBuffer, nParMAResize_Size) == 0){nParMAResize_reset = -1; break;}
    if(ArrayResize(dParMA_TEMPBUFFER, nParMAResize_Size) == 0){nParMAResize_reset = -1; break;}
    if(ArrayResize(nParMA_sum_x ,     nParMAResize_Size) == 0){nParMAResize_reset = -1; break;}
    if(ArrayResize(nParMA_sum_x2,     nParMAResize_Size) == 0){nParMAResize_reset = -1; break;}
    if(ArrayResize(nParMA_sum_x3,     nParMAResize_Size) == 0){nParMAResize_reset = -1; break;}
    if(ArrayResize(nParMA_sum_x4,     nParMAResize_Size) == 0){nParMAResize_reset = -1; break;}
    if(ArrayResize(nParMA_TIME,       nParMAResize_Size) == 0){nParMAResize_reset = -1; break;}
    //----++----------------------------------------------------------------------------------+
    nParMAResize_cycle = 1;
   }
  //--+
  if (nParMAResize_reset == -1)
   {
    Print("ParMASeriesResize: !!!        ParMASeries()_");
    int nParMAResize_Error = GetLastError();
    if(nParMAResize_Error > 4000)
               Print(StringConcatenate("ParMASeriesResize(): ", ParMA_ErrDescr(nParMAResize_Error)));    
    nParMA_Resize = -2;
    return(0);
   }
  else  
   {
    Print(StringConcatenate("ParMASeriesResize: ParMASeries()size = ", nParMAResize_Size));
    nParMA_Resize = nParMAResize_Size;
    return(nParMAResize_Size);
   }  
//----+
 }
//--+ --------------------------------------------------------------------------------------------+
/*
//+X====================================================================================================X+
ParMASeriesAlert -                    |
 ParMASeries_                                                                                     |
  --------------------------    --------------------------                               |
ParMASeriesAlert_Number                                                                                  |
ParMASeriesAlert_ExternVar      nParMA_Phase                        |
ParMASeriesAlert_name      nParMA_Length,  ParMASeriesAlert_Number=0_|                                                  
  --------------------------    -----------------------                               |
  int init()                                                                                             |
//----                                                                                                   |
 -                                                            |
                                                                                                         |
//----                                            |                                                           
ParMASeriesAlert(0,"Length1",Length1);                                                                   |
ParMASeriesAlert(0,"Length2",Length2);                                                                   |
//----                                                                            |
return(0);                                                                                               |
}                                                                                                        |
//+X====================================================================================================X+
*/
void ParMASeriesAlert
 (int ParMASeriesAlert_Number, string ParMASeriesAlert_name, int ParMASeriesAlert_ExternVar)
 {
  //----        ==========================+ 
   if (ParMASeriesAlert_Number == 0)
     if (ParMASeriesAlert_ExternVar < 3)
          Alert(StringConcatenate(" ", ParMASeriesAlert_name, "     3", 
                      "    ", ParMASeriesAlert_ExternVar, "    3"));
   int ParMASeriesAlert_MaxPeriod = ArrayRange(dParMA_TEMPBUFFER, 1); 
   if (ParMASeriesAlert_Number == 0)
    if (ParMASeriesAlert_ExternVar > ParMASeriesAlert_MaxPeriod)
          Alert(StringConcatenate(" ", ParMASeriesAlert_name, "     ", ParMASeriesAlert_MaxPeriod, 
                  "    ", ParMASeriesAlert_ExternVar, "_    ", ParMASeriesAlert_MaxPeriod, "_",
                                       "      nParMA_period,    ",
                                                                            " dParMA_TempBuffer  dParMA_TEMPBUFFER  ParMASeries"));       
 }
//--+ -------------------------------------------------------------------------------------------+

//     01_12_2006  
//+X================================================================X+
//|                                     ParMA_ErrDescr_RUS(MQL4)_mqh |
//|                      Copyright  2004, MetaQuotes Software Corp_ |
//|                                       http://www_metaquotes_net/ |
//+X================================================================X+
string ParMA_ErrDescr(int error_code)
 {
  string error_string;
//----
  switch(error_code)
    {
     //---- MQL4  
     case 4000: error_string = StringConcatenate("  = ",error_code,"_  ");                                                  break;
     case 4001: error_string = StringConcatenate("  = ",error_code,"_   ");                              break;
     case 4002: error_string = StringConcatenate("  = ",error_code,"_      ");                 break;
     case 4003: error_string = StringConcatenate("  = ",error_code,"_     ");                                break;
     case 4004: error_string = StringConcatenate("  = ",error_code,"_     ");                break;
     case 4005: error_string = StringConcatenate("  = ",error_code,"_       ");                 break;
     case 4006: error_string = StringConcatenate("  = ",error_code,"_     ");                         break;
     case 4007: error_string = StringConcatenate("  = ",error_code,"_     ");                             break;
     case 4008: error_string = StringConcatenate("  = ",error_code,"_  ");                                 break;
     case 4009: error_string = StringConcatenate("  = ",error_code,"_    ");                       break;
     case 4010: error_string = StringConcatenate("  = ",error_code,"_     ");                           break;
     case 4011: error_string = StringConcatenate("  = ",error_code,"_   ");                                      break;
     case 4012: error_string = StringConcatenate("  = ",error_code,"_     ");                                  break;
     case 4013: error_string = StringConcatenate("  = ",error_code,"_   ");                                             break;
     case 4014: error_string = StringConcatenate("  = ",error_code,"_  ");                                         break;
     case 4015: error_string = StringConcatenate("  = ",error_code,"_   (never generated error)");                break;
     case 4016: error_string = StringConcatenate("  = ",error_code,"_  ");                                 break;
     case 4017: error_string = StringConcatenate("  = ",error_code,"_  DLL  ");                                     break;
     case 4018: error_string = StringConcatenate("  = ",error_code,"_   ");                             break;
     case 4019: error_string = StringConcatenate("  = ",error_code,"_   ");                                  break;
     case 4020: error_string = StringConcatenate("  = ",error_code,"_      ");            break;
     case 4021: error_string = StringConcatenate("  = ",error_code,"_    ,   ");     break;
     case 4022: error_string = StringConcatenate("  = ",error_code,"_   (never generated error)");                      break;
     case 4050: error_string = StringConcatenate("  = ",error_code,"_    ");                  break;
     case 4051: error_string = StringConcatenate("  = ",error_code,"_    ");                     break;
     case 4052: error_string = StringConcatenate("  = ",error_code,"_    ");                         break;
     case 4053: error_string = StringConcatenate("  = ",error_code,"_  ");                                              break;
     case 4054: error_string = StringConcatenate("  = ",error_code,"_   -");                break;
     case 4055: error_string = StringConcatenate("  = ",error_code,"_   ");                         break;
     case 4056: error_string = StringConcatenate("  = ",error_code,"_  ");                                        break;
     case 4057: error_string = StringConcatenate("  = ",error_code,"_    ");                     break;
     case 4058: error_string = StringConcatenate("  = ",error_code,"_    ");                         break;
     case 4059: error_string = StringConcatenate("  = ",error_code,"_      ");                      break;
     case 4060: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4061: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4062: error_string = StringConcatenate("  = ",error_code,"_    string");                              break;
     case 4063: error_string = StringConcatenate("  = ",error_code,"_    integer");                             break;
     case 4064: error_string = StringConcatenate("  = ",error_code,"_    double");                              break;
     case 4065: error_string = StringConcatenate("  = ",error_code,"_     ");                       break;
     case 4066: error_string = StringConcatenate("  = ",error_code,"_      ");      break;
     case 4067: error_string = StringConcatenate("  = ",error_code,"_     ");                     break;
     case 4099: error_string = StringConcatenate("  = ",error_code,"_  ");                                                 break;
     case 4100: error_string = StringConcatenate("  = ",error_code,"_     ");                                  break;
     case 4101: error_string = StringConcatenate("  = ",error_code,"_   ");                                      break;
     case 4102: error_string = StringConcatenate("  = ",error_code,"_    ");                               break;
     case 4103: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4104: error_string = StringConcatenate("  = ",error_code,"_     ");                         break;
     case 4105: error_string = StringConcatenate("  = ",error_code,"_     ");                                     break;
     case 4106: error_string = StringConcatenate("  = ",error_code,"_  ");                                          break;
     case 4107: error_string = StringConcatenate("  = ",error_code,"_      ");             break;
     case 4108: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4109: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4110: error_string = StringConcatenate("  = ",error_code,"_    ");                                break;
     case 4111: error_string = StringConcatenate("  = ",error_code,"_    ");                               break;
     case 4200: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4201: error_string = StringConcatenate("  = ",error_code,"_    ");                      break;
     case 4202: error_string = StringConcatenate("  = ",error_code,"_   ");                                        break;
     case 4203: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4204: error_string = StringConcatenate("  = ",error_code,"_   ");                                           break;
     case 4205: error_string = StringConcatenate("  = ",error_code,"_   ");                                    break;
     case 4206: error_string = StringConcatenate("  = ",error_code,"_    ");                                break;
     case 4207: error_string = StringConcatenate("  = ",error_code,"_     ");                                break;
     default:   error_string = StringConcatenate("  = ",error_code,"_  ");
    }
//----
  return(error_string);
 }
//+------------------------------------------------------------------+


